import 'package:equatable/equatable.dart';
import 'package:json_annotation/json_annotation.dart';
import 'package:ocg_profile/ocg_profile.dart';

part 'comment.g.dart';

@JsonSerializable(explicitToJson: true)
class Comment extends Equatable {
  final String id;
  final String postId;
  final Profile profile;
  final DateTime recordedAt;
  final String description;
  @JsonKey(ignore: true)
  final bool isSelf;

  Comment(
    this.id,
    this.postId,
    this.profile,
    this.recordedAt,
    this.description,
  ) : this.isSelf = false;

  Comment.named(
      {this.id,
      this.postId,
      this.profile,
      this.recordedAt,
      this.description,
      this.isSelf});

  Map<String, dynamic> toJson() => _$CommentToJson(this);

  factory Comment.fromJson(json) => _$CommentFromJson(json);

  Comment copyWith(
      {String id,
      String postId,
      String description,
      Profile profile,
      DateTime recordedAt,
      bool isSelf}) {
    return Comment.named(
        id: id ?? this.id,
        postId: postId ?? this.postId,
        profile: profile ?? this.profile,
        description: description ?? this.description,
        recordedAt: recordedAt ?? this.recordedAt,
        isSelf: isSelf ?? this.isSelf);
  }

  @override
  List<Object> get props => [id];
}
