import 'package:json_annotation/json_annotation.dart';

part 'hashtag.g.dart';

@JsonSerializable(explicitToJson: true)
class Hashtag {
  final String id;
  final String title;
  final String hash;

  Hashtag(this.id, this.title, this.hash);

  Hashtag.named({
    this.id,
    this.title,
    this.hash,
  });

  Map<String, dynamic> toJson() => _$HashtagToJson(this);

  factory Hashtag.fromJson(json) => _$HashtagFromJson(json);

  Hashtag copyWith({String id, String title, String hash}) {
    return Hashtag.named(
        id: id ?? this.id, title: title ?? this.title, hash: hash ?? this.hash);
  }

  String get tag => "#$title";
}
