import 'package:ocg_app/ocg_app.dart';
import 'package:ocg_location/ocg_location.dart';
import 'package:ocg_post/ocg_post.dart';

import 'package:ocg_post/src/models/post.dart';

abstract class PostRepository extends Crud<Post> {
  Future<AppResponse<List<Post>>> getFollowingPosts(
      {int count = 10, int page = 1, Post after});

  Future<AppResponse<List<Post>>> getNearbyPosts(Position position,
      {int count = 10, Post after});

  Future<AppResponse<bool>> reactToPost(
      String postId, UserReaction userReaction);

  Future<AppResponse<bool>> deleteReactToPost(
      String postId, UserReaction userReaction);

  Future<AppResponse<List<Post>>> getProfilePosts(String profileId,
      {int count = 10, int page = 1});

  Future<AppResponse<List<Post>>> getHashtagPosts(Hashtag hashtag,
      {int count = 10, int page = 1});
}
