import 'package:ocg_app/ocg_app.dart';
import 'package:ocg_post/ocg_post.dart';

abstract class PostReactionRepository {
  Future<AppResponse<List<UserReaction>>> getMyReactions(String postId);
  Future<AppResponse<bool>> deleteMyReaction(
      String postId, UserReaction userReaction);
  Future<AppResponse<bool>> reactToPost(
      String postId, UserReaction userReaction);
  Future<AppResponse<bool>> deleteReactToPost(
      String postId, UserReaction userReaction);
  Future<AppResponse<List<PostReaction>>> getPostReactions(
    String postId,
  );
  Future<AppResponse<List<UserReaction>>> getReactionsByType(
      String postId, String type);
  Future<AppResponse<List<UserReaction>>> getReactions(String postId);
}
